# Définit une image Docker à utiliser pour les jobs,
# si une image n'est pas spécifiée pour un job.
# Pas obligatoire !! On peut définir une image par stage
# default:
#   image: node:lts-alpine

# Définit les étapes de pipeline.
# Chaque étape est exécutée dans l'ordre défini.
stages:
  - install
  - lint_backend
  - lint_frontend
  # - test_backend
  # - test_frontend
  # - build_backend_image
  # - build_frontend_image
  # - test_e2e
  # - push_images

# ICI => cache (pour les node_modules)

install:
  stage: install
  script:
    - echo "Installing dependencies with npm..."
    - sleep 5

lint_backend:
  stage: lint_backend
  script:
    - echo "Linting backend..."
    - sleep 5
  needs:
    - install

lint_frontend:
  stage: lint_frontend
  script:
    - echo "Linting frontend..."
    - sleep 5
  needs:
    - install

# TODO => ajouter
# - test_backend
# - test_frontend
# - build_backend_image
# - build_frontend_image

# Désactivé pour le moment
# LAISSÉ car il démontre par exemple l'utilisation
# de dépendances multiples, et de services
# test_e2e:
#   image: docker:latest
#   services:
#     - docker:dind
#   stage: test_e2e
#   script:
#     - echo "Running end-to-end tests..."
#     - sleep 5
#   needs:
#     - build_backend_image
#     - build_frontend_image

# Désactivé pour le moment
# push_images:
#   stage: push_images
#   script:
#     - echo "Pushing Docker images to registry..."
#     - cat toto.txt
#     - sleep 5
#   needs:
#     - test_e2e